// Digital Cash
// Steven Kappes / Justin Fiedler

import java.util.*;
import java.math.*;
import java.security.*;
import javax.crypto.*;

public class ByteArray
{
	private byte [] data = null;

	public ByteArray()
	{
	}

	public ByteArray(byte [] d)
	{
		data = new byte[d.length];
		DigitalCash.CopyAllBytes(data, d, 0);
	}
	
	public ByteArray(BigInteger d)
	{
		data = new byte[d.toByteArray().length];
		DigitalCash.CopyAllBytes(data, d.toByteArray(), 0);
	}

	public ByteArray(String s)
	{
		data = DigitalCash.StringToBytes(s);
	}

	public byte [] toByteArray()
	{
		return data;
	}
	
	public ByteArray xor(ByteArray bytes)
	{
		if (bytes.toByteArray().length != data.length) return null;
	
		byte [] d = new byte[data.length];
		DigitalCash.CopyAllBytes(d, bytes.toByteArray(), 0);
		
		for (int i = 0; i < d.length; i++)
			d[i] ^= data[i];

		return new ByteArray(d);
	}
	
	public boolean equals(ByteArray array)
	{
		byte [] d = array.toByteArray();

		if (d.length != data.length) return false;

		for (int i = 0; i < data.length; i++) {
			if (data[i] != d[i]) {
				return false;
			}
		}

		return true;
	}

	public BigInteger toInteger()
	{
		return new BigInteger(data);
	}

	public String toString()
	{
		return DigitalCash.BytesToString(data);
	}

	public ByteArray appendBytes(ByteArray bytes)
	{
		byte [] d = new byte[data.length + bytes.toByteArray().length];

		DigitalCash.CopyAllBytes(d, data, 0);
		DigitalCash.CopyAllBytes(d, bytes.toByteArray(), data.length);

		return new ByteArray(d);
	}
}
