import java.io.*;
import java.net.*;
import java.util.*;

import javax.net.ssl.*;
import java.security.cert.*;
import java.security.cert.Certificate;
import java.security.*;
import org.w3c.dom.Document;



   /**
     * helper class implements DOMProcessor interface.  It gets notified
     * when response in received.  It uses a typical "blocking queue" pattern.
     */
    class Receiver implements DOMProcessor {
	XMLSocketThread xml;

	Receiver(XMLSocketThread xml) {
	    this.xml = xml;
	}

	LinkedList<Document> q = new LinkedList<Document>();

	/**
	 * This method blocks until there is something in the queue to return
	 */
	public synchronized Document get() {
	    while (q.isEmpty()) {
		try {
		    wait();
		} catch (InterruptedException ex) {
		    ex.printStackTrace();
		}
	    }
	    return (Document) q.removeFirst();
	}
	/**
	 * this method is called from the XMLSocketThread when a message from
	 * the server is received
	 */
	public synchronized void process(Document doc) {
	    q.add(doc);
	    notify();
	}
    }
